# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetGroupTransitiveMembershipsResult',
    'AwaitableGetGroupTransitiveMembershipsResult',
    'get_group_transitive_memberships',
    'get_group_transitive_memberships_output',
]

@pulumi.output_type
class GetGroupTransitiveMembershipsResult:
    """
    A collection of values returned by getGroupTransitiveMemberships.
    """
    def __init__(__self__, group=None, id=None, memberships=None):
        if group and not isinstance(group, str):
            raise TypeError("Expected argument 'group' to be a str")
        pulumi.set(__self__, "group", group)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if memberships and not isinstance(memberships, list):
            raise TypeError("Expected argument 'memberships' to be a list")
        pulumi.set(__self__, "memberships", memberships)

    @property
    @pulumi.getter
    def group(self) -> builtins.str:
        return pulumi.get(self, "group")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def memberships(self) -> Sequence['outputs.GetGroupTransitiveMembershipsMembershipResult']:
        """
        The list of memberships under the given group. Structure is documented below.
        """
        return pulumi.get(self, "memberships")


class AwaitableGetGroupTransitiveMembershipsResult(GetGroupTransitiveMembershipsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetGroupTransitiveMembershipsResult(
            group=self.group,
            id=self.id,
            memberships=self.memberships)


def get_group_transitive_memberships(group: Optional[builtins.str] = None,
                                     opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetGroupTransitiveMembershipsResult:
    """
    Use this data source to get list of the Cloud Identity Group Memberships within a given Group. Whereas `cloudidentity_get_group_memberships` returns details of only direct members of the group, `cloudidentity_get_group_transitive_memberships` will return details about both direct and indirect members. For example, a user is an indirect member of Group A if the user is a direct member of Group B and Group B is a direct member of Group A.

    To get more information about TransitiveGroupMembership, see:

    * [API documentation](https://cloud.google.com/identity/docs/reference/rest/v1/groups.memberships/searchTransitiveMemberships)
    * How-to Guides
        * [Official Documentation](https://cloud.google.com/identity/docs/how-to/memberships-google-groups)

    ## Example Usage

    ```python
    import pulumi
    import pulumi_gcp as gcp

    members = gcp.cloudidentity.get_group_transitive_memberships(group="groups/123eab45c6defghi")
    ```


    :param builtins.str group: The parent Group resource to search transitive memberships in. Must be of the form groups/{group_id}.
    """
    __args__ = dict()
    __args__['group'] = group
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('gcp:cloudidentity/getGroupTransitiveMemberships:getGroupTransitiveMemberships', __args__, opts=opts, typ=GetGroupTransitiveMembershipsResult).value

    return AwaitableGetGroupTransitiveMembershipsResult(
        group=pulumi.get(__ret__, 'group'),
        id=pulumi.get(__ret__, 'id'),
        memberships=pulumi.get(__ret__, 'memberships'))
def get_group_transitive_memberships_output(group: Optional[pulumi.Input[builtins.str]] = None,
                                            opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetGroupTransitiveMembershipsResult]:
    """
    Use this data source to get list of the Cloud Identity Group Memberships within a given Group. Whereas `cloudidentity_get_group_memberships` returns details of only direct members of the group, `cloudidentity_get_group_transitive_memberships` will return details about both direct and indirect members. For example, a user is an indirect member of Group A if the user is a direct member of Group B and Group B is a direct member of Group A.

    To get more information about TransitiveGroupMembership, see:

    * [API documentation](https://cloud.google.com/identity/docs/reference/rest/v1/groups.memberships/searchTransitiveMemberships)
    * How-to Guides
        * [Official Documentation](https://cloud.google.com/identity/docs/how-to/memberships-google-groups)

    ## Example Usage

    ```python
    import pulumi
    import pulumi_gcp as gcp

    members = gcp.cloudidentity.get_group_transitive_memberships(group="groups/123eab45c6defghi")
    ```


    :param builtins.str group: The parent Group resource to search transitive memberships in. Must be of the form groups/{group_id}.
    """
    __args__ = dict()
    __args__['group'] = group
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('gcp:cloudidentity/getGroupTransitiveMemberships:getGroupTransitiveMemberships', __args__, opts=opts, typ=GetGroupTransitiveMembershipsResult)
    return __ret__.apply(lambda __response__: GetGroupTransitiveMembershipsResult(
        group=pulumi.get(__response__, 'group'),
        id=pulumi.get(__response__, 'id'),
        memberships=pulumi.get(__response__, 'memberships')))
