# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'SQuotaPreferenceQuotaConfigArgs',
    'SQuotaPreferenceQuotaConfigArgsDict',
]

MYPY = False

if not MYPY:
    class SQuotaPreferenceQuotaConfigArgsDict(TypedDict):
        preferred_value: pulumi.Input[builtins.str]
        """
        The preferred value. Must be greater than or equal to -1. If set to -1, it means the value is "unlimited".
        """
        annotations: NotRequired[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]
        """
        The annotations map for clients to store small amounts of arbitrary data. Do not put PII or other sensitive information here. See https://google.aip.dev/128#annotations.
        An object containing a list of "key: value" pairs. Example: `{ "name": "wrench", "mass": "1.3kg", "count": "3" }`.
        """
        granted_value: NotRequired[pulumi.Input[builtins.str]]
        """
        (Output)
        Granted quota value.
        """
        request_origin: NotRequired[pulumi.Input[builtins.str]]
        """
        (Output)
        The origin of the quota preference request.

        - - -
        """
        state_detail: NotRequired[pulumi.Input[builtins.str]]
        """
        (Output)
        Optional details about the state of this quota preference.
        """
        trace_id: NotRequired[pulumi.Input[builtins.str]]
        """
        (Output)
        The trace id that the Google Cloud uses to provision the requested quota. This trace id may be used by the client to contact Cloud support to track the state of a quota preference request. The trace id is only produced for increase requests and is unique for each request. The quota decrease requests do not have a trace id.
        """
elif False:
    SQuotaPreferenceQuotaConfigArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class SQuotaPreferenceQuotaConfigArgs:
    def __init__(__self__, *,
                 preferred_value: pulumi.Input[builtins.str],
                 annotations: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 granted_value: Optional[pulumi.Input[builtins.str]] = None,
                 request_origin: Optional[pulumi.Input[builtins.str]] = None,
                 state_detail: Optional[pulumi.Input[builtins.str]] = None,
                 trace_id: Optional[pulumi.Input[builtins.str]] = None):
        """
        :param pulumi.Input[builtins.str] preferred_value: The preferred value. Must be greater than or equal to -1. If set to -1, it means the value is "unlimited".
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] annotations: The annotations map for clients to store small amounts of arbitrary data. Do not put PII or other sensitive information here. See https://google.aip.dev/128#annotations.
               An object containing a list of "key: value" pairs. Example: `{ "name": "wrench", "mass": "1.3kg", "count": "3" }`.
        :param pulumi.Input[builtins.str] granted_value: (Output)
               Granted quota value.
        :param pulumi.Input[builtins.str] request_origin: (Output)
               The origin of the quota preference request.
               
               - - -
        :param pulumi.Input[builtins.str] state_detail: (Output)
               Optional details about the state of this quota preference.
        :param pulumi.Input[builtins.str] trace_id: (Output)
               The trace id that the Google Cloud uses to provision the requested quota. This trace id may be used by the client to contact Cloud support to track the state of a quota preference request. The trace id is only produced for increase requests and is unique for each request. The quota decrease requests do not have a trace id.
        """
        pulumi.set(__self__, "preferred_value", preferred_value)
        if annotations is not None:
            pulumi.set(__self__, "annotations", annotations)
        if granted_value is not None:
            pulumi.set(__self__, "granted_value", granted_value)
        if request_origin is not None:
            pulumi.set(__self__, "request_origin", request_origin)
        if state_detail is not None:
            pulumi.set(__self__, "state_detail", state_detail)
        if trace_id is not None:
            pulumi.set(__self__, "trace_id", trace_id)

    @property
    @pulumi.getter(name="preferredValue")
    def preferred_value(self) -> pulumi.Input[builtins.str]:
        """
        The preferred value. Must be greater than or equal to -1. If set to -1, it means the value is "unlimited".
        """
        return pulumi.get(self, "preferred_value")

    @preferred_value.setter
    def preferred_value(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "preferred_value", value)

    @property
    @pulumi.getter
    def annotations(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]:
        """
        The annotations map for clients to store small amounts of arbitrary data. Do not put PII or other sensitive information here. See https://google.aip.dev/128#annotations.
        An object containing a list of "key: value" pairs. Example: `{ "name": "wrench", "mass": "1.3kg", "count": "3" }`.
        """
        return pulumi.get(self, "annotations")

    @annotations.setter
    def annotations(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "annotations", value)

    @property
    @pulumi.getter(name="grantedValue")
    def granted_value(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        (Output)
        Granted quota value.
        """
        return pulumi.get(self, "granted_value")

    @granted_value.setter
    def granted_value(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "granted_value", value)

    @property
    @pulumi.getter(name="requestOrigin")
    def request_origin(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        (Output)
        The origin of the quota preference request.

        - - -
        """
        return pulumi.get(self, "request_origin")

    @request_origin.setter
    def request_origin(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "request_origin", value)

    @property
    @pulumi.getter(name="stateDetail")
    def state_detail(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        (Output)
        Optional details about the state of this quota preference.
        """
        return pulumi.get(self, "state_detail")

    @state_detail.setter
    def state_detail(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "state_detail", value)

    @property
    @pulumi.getter(name="traceId")
    def trace_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        (Output)
        The trace id that the Google Cloud uses to provision the requested quota. This trace id may be used by the client to contact Cloud support to track the state of a quota preference request. The trace id is only produced for increase requests and is unique for each request. The quota decrease requests do not have a trace id.
        """
        return pulumi.get(self, "trace_id")

    @trace_id.setter
    def trace_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "trace_id", value)


