# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['NetworkFirewallPolicyWithRulesArgs', 'NetworkFirewallPolicyWithRules']

@pulumi.input_type
class NetworkFirewallPolicyWithRulesArgs:
    def __init__(__self__, *,
                 rules: pulumi.Input[Sequence[pulumi.Input['NetworkFirewallPolicyWithRulesRuleArgs']]],
                 description: Optional[pulumi.Input[builtins.str]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 project: Optional[pulumi.Input[builtins.str]] = None):
        """
        The set of arguments for constructing a NetworkFirewallPolicyWithRules resource.
        :param pulumi.Input[Sequence[pulumi.Input['NetworkFirewallPolicyWithRulesRuleArgs']]] rules: A list of firewall policy rules.
               Structure is documented below.
        :param pulumi.Input[builtins.str] description: (Output)
               A description of the rule.
        :param pulumi.Input[builtins.str] name: User-provided name of the Network firewall policy.
               The name should be unique in the project in which the firewall policy is created.
               The name must be 1-63 characters long, and comply with RFC1035. Specifically,
               the name must be 1-63 characters long and match the regular expression a-z?
               which means the first character must be a lowercase letter, and all following characters must be a dash,
               lowercase letter, or digit, except the last character, which cannot be a dash.
        """
        pulumi.set(__self__, "rules", rules)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if project is not None:
            pulumi.set(__self__, "project", project)

    @property
    @pulumi.getter
    def rules(self) -> pulumi.Input[Sequence[pulumi.Input['NetworkFirewallPolicyWithRulesRuleArgs']]]:
        """
        A list of firewall policy rules.
        Structure is documented below.
        """
        return pulumi.get(self, "rules")

    @rules.setter
    def rules(self, value: pulumi.Input[Sequence[pulumi.Input['NetworkFirewallPolicyWithRulesRuleArgs']]]):
        pulumi.set(self, "rules", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        (Output)
        A description of the rule.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        User-provided name of the Network firewall policy.
        The name should be unique in the project in which the firewall policy is created.
        The name must be 1-63 characters long, and comply with RFC1035. Specifically,
        the name must be 1-63 characters long and match the regular expression a-z?
        which means the first character must be a lowercase letter, and all following characters must be a dash,
        lowercase letter, or digit, except the last character, which cannot be a dash.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def project(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "project")

    @project.setter
    def project(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "project", value)


@pulumi.input_type
class _NetworkFirewallPolicyWithRulesState:
    def __init__(__self__, *,
                 creation_timestamp: Optional[pulumi.Input[builtins.str]] = None,
                 description: Optional[pulumi.Input[builtins.str]] = None,
                 fingerprint: Optional[pulumi.Input[builtins.str]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 network_firewall_policy_id: Optional[pulumi.Input[builtins.str]] = None,
                 predefined_rules: Optional[pulumi.Input[Sequence[pulumi.Input['NetworkFirewallPolicyWithRulesPredefinedRuleArgs']]]] = None,
                 project: Optional[pulumi.Input[builtins.str]] = None,
                 rule_tuple_count: Optional[pulumi.Input[builtins.int]] = None,
                 rules: Optional[pulumi.Input[Sequence[pulumi.Input['NetworkFirewallPolicyWithRulesRuleArgs']]]] = None,
                 self_link: Optional[pulumi.Input[builtins.str]] = None,
                 self_link_with_id: Optional[pulumi.Input[builtins.str]] = None):
        """
        Input properties used for looking up and filtering NetworkFirewallPolicyWithRules resources.
        :param pulumi.Input[builtins.str] creation_timestamp: Creation timestamp in RFC3339 text format.
        :param pulumi.Input[builtins.str] description: (Output)
               A description of the rule.
        :param pulumi.Input[builtins.str] fingerprint: Fingerprint of the resource. This field is used internally during updates of this resource.
        :param pulumi.Input[builtins.str] name: User-provided name of the Network firewall policy.
               The name should be unique in the project in which the firewall policy is created.
               The name must be 1-63 characters long, and comply with RFC1035. Specifically,
               the name must be 1-63 characters long and match the regular expression a-z?
               which means the first character must be a lowercase letter, and all following characters must be a dash,
               lowercase letter, or digit, except the last character, which cannot be a dash.
        :param pulumi.Input[builtins.str] network_firewall_policy_id: The unique identifier for the resource. This identifier is defined by the server.
        :param pulumi.Input[Sequence[pulumi.Input['NetworkFirewallPolicyWithRulesPredefinedRuleArgs']]] predefined_rules: A list of firewall policy pre-defined rules.
               Structure is documented below.
        :param pulumi.Input[builtins.int] rule_tuple_count: Total count of all firewall policy rule tuples. A firewall policy can not exceed a set number of tuples.
        :param pulumi.Input[Sequence[pulumi.Input['NetworkFirewallPolicyWithRulesRuleArgs']]] rules: A list of firewall policy rules.
               Structure is documented below.
        :param pulumi.Input[builtins.str] self_link: Server-defined URL for the resource.
        :param pulumi.Input[builtins.str] self_link_with_id: Server-defined URL for this resource with the resource id.
        """
        if creation_timestamp is not None:
            pulumi.set(__self__, "creation_timestamp", creation_timestamp)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if fingerprint is not None:
            pulumi.set(__self__, "fingerprint", fingerprint)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if network_firewall_policy_id is not None:
            pulumi.set(__self__, "network_firewall_policy_id", network_firewall_policy_id)
        if predefined_rules is not None:
            pulumi.set(__self__, "predefined_rules", predefined_rules)
        if project is not None:
            pulumi.set(__self__, "project", project)
        if rule_tuple_count is not None:
            pulumi.set(__self__, "rule_tuple_count", rule_tuple_count)
        if rules is not None:
            pulumi.set(__self__, "rules", rules)
        if self_link is not None:
            pulumi.set(__self__, "self_link", self_link)
        if self_link_with_id is not None:
            pulumi.set(__self__, "self_link_with_id", self_link_with_id)

    @property
    @pulumi.getter(name="creationTimestamp")
    def creation_timestamp(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Creation timestamp in RFC3339 text format.
        """
        return pulumi.get(self, "creation_timestamp")

    @creation_timestamp.setter
    def creation_timestamp(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "creation_timestamp", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        (Output)
        A description of the rule.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def fingerprint(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Fingerprint of the resource. This field is used internally during updates of this resource.
        """
        return pulumi.get(self, "fingerprint")

    @fingerprint.setter
    def fingerprint(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "fingerprint", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        User-provided name of the Network firewall policy.
        The name should be unique in the project in which the firewall policy is created.
        The name must be 1-63 characters long, and comply with RFC1035. Specifically,
        the name must be 1-63 characters long and match the regular expression a-z?
        which means the first character must be a lowercase letter, and all following characters must be a dash,
        lowercase letter, or digit, except the last character, which cannot be a dash.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="networkFirewallPolicyId")
    def network_firewall_policy_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The unique identifier for the resource. This identifier is defined by the server.
        """
        return pulumi.get(self, "network_firewall_policy_id")

    @network_firewall_policy_id.setter
    def network_firewall_policy_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "network_firewall_policy_id", value)

    @property
    @pulumi.getter(name="predefinedRules")
    def predefined_rules(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['NetworkFirewallPolicyWithRulesPredefinedRuleArgs']]]]:
        """
        A list of firewall policy pre-defined rules.
        Structure is documented below.
        """
        return pulumi.get(self, "predefined_rules")

    @predefined_rules.setter
    def predefined_rules(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['NetworkFirewallPolicyWithRulesPredefinedRuleArgs']]]]):
        pulumi.set(self, "predefined_rules", value)

    @property
    @pulumi.getter
    def project(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "project")

    @project.setter
    def project(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "project", value)

    @property
    @pulumi.getter(name="ruleTupleCount")
    def rule_tuple_count(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        Total count of all firewall policy rule tuples. A firewall policy can not exceed a set number of tuples.
        """
        return pulumi.get(self, "rule_tuple_count")

    @rule_tuple_count.setter
    def rule_tuple_count(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "rule_tuple_count", value)

    @property
    @pulumi.getter
    def rules(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['NetworkFirewallPolicyWithRulesRuleArgs']]]]:
        """
        A list of firewall policy rules.
        Structure is documented below.
        """
        return pulumi.get(self, "rules")

    @rules.setter
    def rules(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['NetworkFirewallPolicyWithRulesRuleArgs']]]]):
        pulumi.set(self, "rules", value)

    @property
    @pulumi.getter(name="selfLink")
    def self_link(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Server-defined URL for the resource.
        """
        return pulumi.get(self, "self_link")

    @self_link.setter
    def self_link(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "self_link", value)

    @property
    @pulumi.getter(name="selfLinkWithId")
    def self_link_with_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Server-defined URL for this resource with the resource id.
        """
        return pulumi.get(self, "self_link_with_id")

    @self_link_with_id.setter
    def self_link_with_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "self_link_with_id", value)


@pulumi.type_token("gcp:compute/networkFirewallPolicyWithRules:NetworkFirewallPolicyWithRules")
class NetworkFirewallPolicyWithRules(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 description: Optional[pulumi.Input[builtins.str]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 project: Optional[pulumi.Input[builtins.str]] = None,
                 rules: Optional[pulumi.Input[Sequence[pulumi.Input[Union['NetworkFirewallPolicyWithRulesRuleArgs', 'NetworkFirewallPolicyWithRulesRuleArgsDict']]]]] = None,
                 __props__=None):
        """
        ## Example Usage

        ### Compute Network Firewall Policy With Rules Full

        ```python
        import pulumi
        import pulumi_gcp as gcp

        project = gcp.organizations.get_project()
        address_group1 = gcp.networksecurity.AddressGroup("address_group_1",
            name="address-group",
            parent=project.id,
            description="Global address group",
            location="global",
            items=["208.80.154.224/32"],
            type="IPV4",
            capacity=100)
        secure_tag_key1 = gcp.tags.TagKey("secure_tag_key_1",
            description="Tag key",
            parent=project.id,
            purpose="GCE_FIREWALL",
            short_name="tag-key",
            purpose_data={
                "network": f"{project.name}/default",
            })
        secure_tag_value1 = gcp.tags.TagValue("secure_tag_value_1",
            description="Tag value",
            parent=secure_tag_key1.id,
            short_name="tag-value")
        security_profile1 = gcp.networksecurity.SecurityProfile("security_profile_1",
            name="sp",
            type="THREAT_PREVENTION",
            parent="organizations/123456789",
            location="global")
        security_profile_group1 = gcp.networksecurity.SecurityProfileGroup("security_profile_group_1",
            name="spg",
            parent="organizations/123456789",
            description="my description",
            threat_prevention_profile=security_profile1.id)
        network = gcp.compute.Network("network",
            name="network",
            auto_create_subnetworks=False)
        primary = gcp.compute.NetworkFirewallPolicyWithRules("primary",
            name="fw-policy",
            description="Terraform test",
            rules=[
                {
                    "description": "tcp rule",
                    "priority": 1000,
                    "enable_logging": True,
                    "action": "allow",
                    "direction": "EGRESS",
                    "match": {
                        "dest_ip_ranges": ["11.100.0.1/32"],
                        "dest_fqdns": [
                            "www.yyy.com",
                            "www.zzz.com",
                        ],
                        "dest_region_codes": [
                            "HK",
                            "IN",
                        ],
                        "dest_threat_intelligences": [
                            "iplist-search-engines-crawlers",
                            "iplist-tor-exit-nodes",
                        ],
                        "dest_address_groups": [address_group1.id],
                        "layer4_configs": [{
                            "ip_protocol": "tcp",
                            "ports": [
                                "8080",
                                "7070",
                            ],
                        }],
                    },
                    "target_secure_tags": [{
                        "name": secure_tag_value1.id,
                    }],
                },
                {
                    "description": "udp rule",
                    "priority": 2000,
                    "enable_logging": False,
                    "action": "deny",
                    "direction": "INGRESS",
                    "disabled": True,
                    "match": {
                        "src_ip_ranges": ["0.0.0.0/0"],
                        "src_fqdns": [
                            "www.abc.com",
                            "www.def.com",
                        ],
                        "src_region_codes": [
                            "US",
                            "CA",
                        ],
                        "src_threat_intelligences": [
                            "iplist-known-malicious-ips",
                            "iplist-public-clouds",
                        ],
                        "src_address_groups": [address_group1.id],
                        "src_secure_tags": [{
                            "name": secure_tag_value1.id,
                        }],
                        "layer4_configs": [{
                            "ip_protocol": "udp",
                        }],
                    },
                },
                {
                    "description": "security profile group rule",
                    "rule_name": "tcp rule",
                    "priority": 3000,
                    "enable_logging": False,
                    "action": "apply_security_profile_group",
                    "direction": "INGRESS",
                    "target_service_accounts": ["test@google.com"],
                    "security_profile_group": security_profile_group1.id.apply(lambda id: f"//networksecurity.googleapis.com/{id}"),
                    "tls_inspect": True,
                    "match": {
                        "src_ip_ranges": ["0.0.0.0/0"],
                        "layer4_configs": [{
                            "ip_protocol": "tcp",
                        }],
                    },
                },
                {
                    "description": "network scope rule 1",
                    "rule_name": "network scope 1",
                    "priority": 4000,
                    "enable_logging": False,
                    "action": "allow",
                    "direction": "INGRESS",
                    "match": {
                        "src_ip_ranges": ["11.100.0.1/32"],
                        "src_network_scope": "VPC_NETWORKS",
                        "src_networks": [network.id],
                        "layer4_configs": [{
                            "ip_protocol": "tcp",
                            "ports": ["8080"],
                        }],
                    },
                },
                {
                    "description": "network scope rule 2",
                    "rule_name": "network scope 2",
                    "priority": 5000,
                    "enable_logging": False,
                    "action": "allow",
                    "direction": "EGRESS",
                    "match": {
                        "dest_ip_ranges": ["0.0.0.0/0"],
                        "dest_network_scope": "INTERNET",
                        "layer4_configs": [{
                            "ip_protocol": "tcp",
                            "ports": ["8080"],
                        }],
                    },
                },
            ])
        ```

        ## Import

        NetworkFirewallPolicyWithRules can be imported using any of these accepted formats:

        * `projects/{{project}}/global/firewallPolicies/{{name}}`

        * `{{project}}/{{name}}`

        * `{{name}}`

        When using the `pulumi import` command, NetworkFirewallPolicyWithRules can be imported using one of the formats above. For example:

        ```sh
        $ pulumi import gcp:compute/networkFirewallPolicyWithRules:NetworkFirewallPolicyWithRules default projects/{{project}}/global/firewallPolicies/{{name}}
        ```

        ```sh
        $ pulumi import gcp:compute/networkFirewallPolicyWithRules:NetworkFirewallPolicyWithRules default {{project}}/{{name}}
        ```

        ```sh
        $ pulumi import gcp:compute/networkFirewallPolicyWithRules:NetworkFirewallPolicyWithRules default {{name}}
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] description: (Output)
               A description of the rule.
        :param pulumi.Input[builtins.str] name: User-provided name of the Network firewall policy.
               The name should be unique in the project in which the firewall policy is created.
               The name must be 1-63 characters long, and comply with RFC1035. Specifically,
               the name must be 1-63 characters long and match the regular expression a-z?
               which means the first character must be a lowercase letter, and all following characters must be a dash,
               lowercase letter, or digit, except the last character, which cannot be a dash.
        :param pulumi.Input[Sequence[pulumi.Input[Union['NetworkFirewallPolicyWithRulesRuleArgs', 'NetworkFirewallPolicyWithRulesRuleArgsDict']]]] rules: A list of firewall policy rules.
               Structure is documented below.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: NetworkFirewallPolicyWithRulesArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        ## Example Usage

        ### Compute Network Firewall Policy With Rules Full

        ```python
        import pulumi
        import pulumi_gcp as gcp

        project = gcp.organizations.get_project()
        address_group1 = gcp.networksecurity.AddressGroup("address_group_1",
            name="address-group",
            parent=project.id,
            description="Global address group",
            location="global",
            items=["208.80.154.224/32"],
            type="IPV4",
            capacity=100)
        secure_tag_key1 = gcp.tags.TagKey("secure_tag_key_1",
            description="Tag key",
            parent=project.id,
            purpose="GCE_FIREWALL",
            short_name="tag-key",
            purpose_data={
                "network": f"{project.name}/default",
            })
        secure_tag_value1 = gcp.tags.TagValue("secure_tag_value_1",
            description="Tag value",
            parent=secure_tag_key1.id,
            short_name="tag-value")
        security_profile1 = gcp.networksecurity.SecurityProfile("security_profile_1",
            name="sp",
            type="THREAT_PREVENTION",
            parent="organizations/123456789",
            location="global")
        security_profile_group1 = gcp.networksecurity.SecurityProfileGroup("security_profile_group_1",
            name="spg",
            parent="organizations/123456789",
            description="my description",
            threat_prevention_profile=security_profile1.id)
        network = gcp.compute.Network("network",
            name="network",
            auto_create_subnetworks=False)
        primary = gcp.compute.NetworkFirewallPolicyWithRules("primary",
            name="fw-policy",
            description="Terraform test",
            rules=[
                {
                    "description": "tcp rule",
                    "priority": 1000,
                    "enable_logging": True,
                    "action": "allow",
                    "direction": "EGRESS",
                    "match": {
                        "dest_ip_ranges": ["11.100.0.1/32"],
                        "dest_fqdns": [
                            "www.yyy.com",
                            "www.zzz.com",
                        ],
                        "dest_region_codes": [
                            "HK",
                            "IN",
                        ],
                        "dest_threat_intelligences": [
                            "iplist-search-engines-crawlers",
                            "iplist-tor-exit-nodes",
                        ],
                        "dest_address_groups": [address_group1.id],
                        "layer4_configs": [{
                            "ip_protocol": "tcp",
                            "ports": [
                                "8080",
                                "7070",
                            ],
                        }],
                    },
                    "target_secure_tags": [{
                        "name": secure_tag_value1.id,
                    }],
                },
                {
                    "description": "udp rule",
                    "priority": 2000,
                    "enable_logging": False,
                    "action": "deny",
                    "direction": "INGRESS",
                    "disabled": True,
                    "match": {
                        "src_ip_ranges": ["0.0.0.0/0"],
                        "src_fqdns": [
                            "www.abc.com",
                            "www.def.com",
                        ],
                        "src_region_codes": [
                            "US",
                            "CA",
                        ],
                        "src_threat_intelligences": [
                            "iplist-known-malicious-ips",
                            "iplist-public-clouds",
                        ],
                        "src_address_groups": [address_group1.id],
                        "src_secure_tags": [{
                            "name": secure_tag_value1.id,
                        }],
                        "layer4_configs": [{
                            "ip_protocol": "udp",
                        }],
                    },
                },
                {
                    "description": "security profile group rule",
                    "rule_name": "tcp rule",
                    "priority": 3000,
                    "enable_logging": False,
                    "action": "apply_security_profile_group",
                    "direction": "INGRESS",
                    "target_service_accounts": ["test@google.com"],
                    "security_profile_group": security_profile_group1.id.apply(lambda id: f"//networksecurity.googleapis.com/{id}"),
                    "tls_inspect": True,
                    "match": {
                        "src_ip_ranges": ["0.0.0.0/0"],
                        "layer4_configs": [{
                            "ip_protocol": "tcp",
                        }],
                    },
                },
                {
                    "description": "network scope rule 1",
                    "rule_name": "network scope 1",
                    "priority": 4000,
                    "enable_logging": False,
                    "action": "allow",
                    "direction": "INGRESS",
                    "match": {
                        "src_ip_ranges": ["11.100.0.1/32"],
                        "src_network_scope": "VPC_NETWORKS",
                        "src_networks": [network.id],
                        "layer4_configs": [{
                            "ip_protocol": "tcp",
                            "ports": ["8080"],
                        }],
                    },
                },
                {
                    "description": "network scope rule 2",
                    "rule_name": "network scope 2",
                    "priority": 5000,
                    "enable_logging": False,
                    "action": "allow",
                    "direction": "EGRESS",
                    "match": {
                        "dest_ip_ranges": ["0.0.0.0/0"],
                        "dest_network_scope": "INTERNET",
                        "layer4_configs": [{
                            "ip_protocol": "tcp",
                            "ports": ["8080"],
                        }],
                    },
                },
            ])
        ```

        ## Import

        NetworkFirewallPolicyWithRules can be imported using any of these accepted formats:

        * `projects/{{project}}/global/firewallPolicies/{{name}}`

        * `{{project}}/{{name}}`

        * `{{name}}`

        When using the `pulumi import` command, NetworkFirewallPolicyWithRules can be imported using one of the formats above. For example:

        ```sh
        $ pulumi import gcp:compute/networkFirewallPolicyWithRules:NetworkFirewallPolicyWithRules default projects/{{project}}/global/firewallPolicies/{{name}}
        ```

        ```sh
        $ pulumi import gcp:compute/networkFirewallPolicyWithRules:NetworkFirewallPolicyWithRules default {{project}}/{{name}}
        ```

        ```sh
        $ pulumi import gcp:compute/networkFirewallPolicyWithRules:NetworkFirewallPolicyWithRules default {{name}}
        ```

        :param str resource_name: The name of the resource.
        :param NetworkFirewallPolicyWithRulesArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(NetworkFirewallPolicyWithRulesArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 description: Optional[pulumi.Input[builtins.str]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 project: Optional[pulumi.Input[builtins.str]] = None,
                 rules: Optional[pulumi.Input[Sequence[pulumi.Input[Union['NetworkFirewallPolicyWithRulesRuleArgs', 'NetworkFirewallPolicyWithRulesRuleArgsDict']]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = NetworkFirewallPolicyWithRulesArgs.__new__(NetworkFirewallPolicyWithRulesArgs)

            __props__.__dict__["description"] = description
            __props__.__dict__["name"] = name
            __props__.__dict__["project"] = project
            if rules is None and not opts.urn:
                raise TypeError("Missing required property 'rules'")
            __props__.__dict__["rules"] = rules
            __props__.__dict__["creation_timestamp"] = None
            __props__.__dict__["fingerprint"] = None
            __props__.__dict__["network_firewall_policy_id"] = None
            __props__.__dict__["predefined_rules"] = None
            __props__.__dict__["rule_tuple_count"] = None
            __props__.__dict__["self_link"] = None
            __props__.__dict__["self_link_with_id"] = None
        super(NetworkFirewallPolicyWithRules, __self__).__init__(
            'gcp:compute/networkFirewallPolicyWithRules:NetworkFirewallPolicyWithRules',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            creation_timestamp: Optional[pulumi.Input[builtins.str]] = None,
            description: Optional[pulumi.Input[builtins.str]] = None,
            fingerprint: Optional[pulumi.Input[builtins.str]] = None,
            name: Optional[pulumi.Input[builtins.str]] = None,
            network_firewall_policy_id: Optional[pulumi.Input[builtins.str]] = None,
            predefined_rules: Optional[pulumi.Input[Sequence[pulumi.Input[Union['NetworkFirewallPolicyWithRulesPredefinedRuleArgs', 'NetworkFirewallPolicyWithRulesPredefinedRuleArgsDict']]]]] = None,
            project: Optional[pulumi.Input[builtins.str]] = None,
            rule_tuple_count: Optional[pulumi.Input[builtins.int]] = None,
            rules: Optional[pulumi.Input[Sequence[pulumi.Input[Union['NetworkFirewallPolicyWithRulesRuleArgs', 'NetworkFirewallPolicyWithRulesRuleArgsDict']]]]] = None,
            self_link: Optional[pulumi.Input[builtins.str]] = None,
            self_link_with_id: Optional[pulumi.Input[builtins.str]] = None) -> 'NetworkFirewallPolicyWithRules':
        """
        Get an existing NetworkFirewallPolicyWithRules resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] creation_timestamp: Creation timestamp in RFC3339 text format.
        :param pulumi.Input[builtins.str] description: (Output)
               A description of the rule.
        :param pulumi.Input[builtins.str] fingerprint: Fingerprint of the resource. This field is used internally during updates of this resource.
        :param pulumi.Input[builtins.str] name: User-provided name of the Network firewall policy.
               The name should be unique in the project in which the firewall policy is created.
               The name must be 1-63 characters long, and comply with RFC1035. Specifically,
               the name must be 1-63 characters long and match the regular expression a-z?
               which means the first character must be a lowercase letter, and all following characters must be a dash,
               lowercase letter, or digit, except the last character, which cannot be a dash.
        :param pulumi.Input[builtins.str] network_firewall_policy_id: The unique identifier for the resource. This identifier is defined by the server.
        :param pulumi.Input[Sequence[pulumi.Input[Union['NetworkFirewallPolicyWithRulesPredefinedRuleArgs', 'NetworkFirewallPolicyWithRulesPredefinedRuleArgsDict']]]] predefined_rules: A list of firewall policy pre-defined rules.
               Structure is documented below.
        :param pulumi.Input[builtins.int] rule_tuple_count: Total count of all firewall policy rule tuples. A firewall policy can not exceed a set number of tuples.
        :param pulumi.Input[Sequence[pulumi.Input[Union['NetworkFirewallPolicyWithRulesRuleArgs', 'NetworkFirewallPolicyWithRulesRuleArgsDict']]]] rules: A list of firewall policy rules.
               Structure is documented below.
        :param pulumi.Input[builtins.str] self_link: Server-defined URL for the resource.
        :param pulumi.Input[builtins.str] self_link_with_id: Server-defined URL for this resource with the resource id.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _NetworkFirewallPolicyWithRulesState.__new__(_NetworkFirewallPolicyWithRulesState)

        __props__.__dict__["creation_timestamp"] = creation_timestamp
        __props__.__dict__["description"] = description
        __props__.__dict__["fingerprint"] = fingerprint
        __props__.__dict__["name"] = name
        __props__.__dict__["network_firewall_policy_id"] = network_firewall_policy_id
        __props__.__dict__["predefined_rules"] = predefined_rules
        __props__.__dict__["project"] = project
        __props__.__dict__["rule_tuple_count"] = rule_tuple_count
        __props__.__dict__["rules"] = rules
        __props__.__dict__["self_link"] = self_link
        __props__.__dict__["self_link_with_id"] = self_link_with_id
        return NetworkFirewallPolicyWithRules(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="creationTimestamp")
    def creation_timestamp(self) -> pulumi.Output[builtins.str]:
        """
        Creation timestamp in RFC3339 text format.
        """
        return pulumi.get(self, "creation_timestamp")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        (Output)
        A description of the rule.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def fingerprint(self) -> pulumi.Output[builtins.str]:
        """
        Fingerprint of the resource. This field is used internally during updates of this resource.
        """
        return pulumi.get(self, "fingerprint")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[builtins.str]:
        """
        User-provided name of the Network firewall policy.
        The name should be unique in the project in which the firewall policy is created.
        The name must be 1-63 characters long, and comply with RFC1035. Specifically,
        the name must be 1-63 characters long and match the regular expression a-z?
        which means the first character must be a lowercase letter, and all following characters must be a dash,
        lowercase letter, or digit, except the last character, which cannot be a dash.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="networkFirewallPolicyId")
    def network_firewall_policy_id(self) -> pulumi.Output[builtins.str]:
        """
        The unique identifier for the resource. This identifier is defined by the server.
        """
        return pulumi.get(self, "network_firewall_policy_id")

    @property
    @pulumi.getter(name="predefinedRules")
    def predefined_rules(self) -> pulumi.Output[Sequence['outputs.NetworkFirewallPolicyWithRulesPredefinedRule']]:
        """
        A list of firewall policy pre-defined rules.
        Structure is documented below.
        """
        return pulumi.get(self, "predefined_rules")

    @property
    @pulumi.getter
    def project(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "project")

    @property
    @pulumi.getter(name="ruleTupleCount")
    def rule_tuple_count(self) -> pulumi.Output[builtins.int]:
        """
        Total count of all firewall policy rule tuples. A firewall policy can not exceed a set number of tuples.
        """
        return pulumi.get(self, "rule_tuple_count")

    @property
    @pulumi.getter
    def rules(self) -> pulumi.Output[Sequence['outputs.NetworkFirewallPolicyWithRulesRule']]:
        """
        A list of firewall policy rules.
        Structure is documented below.
        """
        return pulumi.get(self, "rules")

    @property
    @pulumi.getter(name="selfLink")
    def self_link(self) -> pulumi.Output[builtins.str]:
        """
        Server-defined URL for the resource.
        """
        return pulumi.get(self, "self_link")

    @property
    @pulumi.getter(name="selfLinkWithId")
    def self_link_with_id(self) -> pulumi.Output[builtins.str]:
        """
        Server-defined URL for this resource with the resource id.
        """
        return pulumi.get(self, "self_link_with_id")

