# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'GetServiceConsumersIamPolicyResult',
    'AwaitableGetServiceConsumersIamPolicyResult',
    'get_service_consumers_iam_policy',
    'get_service_consumers_iam_policy_output',
]

@pulumi.output_type
class GetServiceConsumersIamPolicyResult:
    """
    A collection of values returned by getServiceConsumersIamPolicy.
    """
    def __init__(__self__, consumer_project=None, etag=None, id=None, policy_data=None, service_name=None):
        if consumer_project and not isinstance(consumer_project, str):
            raise TypeError("Expected argument 'consumer_project' to be a str")
        pulumi.set(__self__, "consumer_project", consumer_project)
        if etag and not isinstance(etag, str):
            raise TypeError("Expected argument 'etag' to be a str")
        pulumi.set(__self__, "etag", etag)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if policy_data and not isinstance(policy_data, str):
            raise TypeError("Expected argument 'policy_data' to be a str")
        pulumi.set(__self__, "policy_data", policy_data)
        if service_name and not isinstance(service_name, str):
            raise TypeError("Expected argument 'service_name' to be a str")
        pulumi.set(__self__, "service_name", service_name)

    @property
    @pulumi.getter(name="consumerProject")
    def consumer_project(self) -> builtins.str:
        return pulumi.get(self, "consumer_project")

    @property
    @pulumi.getter
    def etag(self) -> builtins.str:
        """
        (Computed) The etag of the IAM policy.
        """
        return pulumi.get(self, "etag")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="policyData")
    def policy_data(self) -> builtins.str:
        """
        (Required only by `endpoints.ConsumersIamPolicy`) The policy data generated by
        a `organizations_get_iam_policy` data source.
        """
        return pulumi.get(self, "policy_data")

    @property
    @pulumi.getter(name="serviceName")
    def service_name(self) -> builtins.str:
        return pulumi.get(self, "service_name")


class AwaitableGetServiceConsumersIamPolicyResult(GetServiceConsumersIamPolicyResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetServiceConsumersIamPolicyResult(
            consumer_project=self.consumer_project,
            etag=self.etag,
            id=self.id,
            policy_data=self.policy_data,
            service_name=self.service_name)


def get_service_consumers_iam_policy(consumer_project: Optional[builtins.str] = None,
                                     service_name: Optional[builtins.str] = None,
                                     opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetServiceConsumersIamPolicyResult:
    """
    Retrieves the current IAM policy data for serviceconsumers
    """
    __args__ = dict()
    __args__['consumerProject'] = consumer_project
    __args__['serviceName'] = service_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('gcp:endpoints/getServiceConsumersIamPolicy:getServiceConsumersIamPolicy', __args__, opts=opts, typ=GetServiceConsumersIamPolicyResult).value

    return AwaitableGetServiceConsumersIamPolicyResult(
        consumer_project=pulumi.get(__ret__, 'consumer_project'),
        etag=pulumi.get(__ret__, 'etag'),
        id=pulumi.get(__ret__, 'id'),
        policy_data=pulumi.get(__ret__, 'policy_data'),
        service_name=pulumi.get(__ret__, 'service_name'))
def get_service_consumers_iam_policy_output(consumer_project: Optional[pulumi.Input[builtins.str]] = None,
                                            service_name: Optional[pulumi.Input[builtins.str]] = None,
                                            opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetServiceConsumersIamPolicyResult]:
    """
    Retrieves the current IAM policy data for serviceconsumers
    """
    __args__ = dict()
    __args__['consumerProject'] = consumer_project
    __args__['serviceName'] = service_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('gcp:endpoints/getServiceConsumersIamPolicy:getServiceConsumersIamPolicy', __args__, opts=opts, typ=GetServiceConsumersIamPolicyResult)
    return __ret__.apply(lambda __response__: GetServiceConsumersIamPolicyResult(
        consumer_project=pulumi.get(__response__, 'consumer_project'),
        etag=pulumi.get(__response__, 'etag'),
        id=pulumi.get(__response__, 'id'),
        policy_data=pulumi.get(__response__, 'policy_data'),
        service_name=pulumi.get(__response__, 'service_name')))
