# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['CodeToolsSettingArgs', 'CodeToolsSetting']

@pulumi.input_type
class CodeToolsSettingArgs:
    def __init__(__self__, *,
                 code_tools_setting_id: pulumi.Input[builtins.str],
                 enabled_tools: pulumi.Input[Sequence[pulumi.Input['CodeToolsSettingEnabledToolArgs']]],
                 labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 location: Optional[pulumi.Input[builtins.str]] = None,
                 project: Optional[pulumi.Input[builtins.str]] = None):
        """
        The set of arguments for constructing a CodeToolsSetting resource.
        :param pulumi.Input[builtins.str] code_tools_setting_id: Id of the Code Tools Setting.
        :param pulumi.Input[Sequence[pulumi.Input['CodeToolsSettingEnabledToolArgs']]] enabled_tools: Represents the full set of enabled tools.
               Structure is documented below.
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] labels: Labels as key value pairs. **Note**: This field is non-authoritative, and will only manage the labels present in your
               configuration. Please refer to the field 'effective_labels' for all of the labels present on the resource.
        :param pulumi.Input[builtins.str] location: Resource ID segment making up resource 'name'. It identifies the resource within its parent collection as described in
               https://google.aip.dev/122.
        """
        pulumi.set(__self__, "code_tools_setting_id", code_tools_setting_id)
        pulumi.set(__self__, "enabled_tools", enabled_tools)
        if labels is not None:
            pulumi.set(__self__, "labels", labels)
        if location is not None:
            pulumi.set(__self__, "location", location)
        if project is not None:
            pulumi.set(__self__, "project", project)

    @property
    @pulumi.getter(name="codeToolsSettingId")
    def code_tools_setting_id(self) -> pulumi.Input[builtins.str]:
        """
        Id of the Code Tools Setting.
        """
        return pulumi.get(self, "code_tools_setting_id")

    @code_tools_setting_id.setter
    def code_tools_setting_id(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "code_tools_setting_id", value)

    @property
    @pulumi.getter(name="enabledTools")
    def enabled_tools(self) -> pulumi.Input[Sequence[pulumi.Input['CodeToolsSettingEnabledToolArgs']]]:
        """
        Represents the full set of enabled tools.
        Structure is documented below.
        """
        return pulumi.get(self, "enabled_tools")

    @enabled_tools.setter
    def enabled_tools(self, value: pulumi.Input[Sequence[pulumi.Input['CodeToolsSettingEnabledToolArgs']]]):
        pulumi.set(self, "enabled_tools", value)

    @property
    @pulumi.getter
    def labels(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]:
        """
        Labels as key value pairs. **Note**: This field is non-authoritative, and will only manage the labels present in your
        configuration. Please refer to the field 'effective_labels' for all of the labels present on the resource.
        """
        return pulumi.get(self, "labels")

    @labels.setter
    def labels(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "labels", value)

    @property
    @pulumi.getter
    def location(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Resource ID segment making up resource 'name'. It identifies the resource within its parent collection as described in
        https://google.aip.dev/122.
        """
        return pulumi.get(self, "location")

    @location.setter
    def location(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "location", value)

    @property
    @pulumi.getter
    def project(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "project")

    @project.setter
    def project(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "project", value)


@pulumi.input_type
class _CodeToolsSettingState:
    def __init__(__self__, *,
                 code_tools_setting_id: Optional[pulumi.Input[builtins.str]] = None,
                 create_time: Optional[pulumi.Input[builtins.str]] = None,
                 effective_labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 enabled_tools: Optional[pulumi.Input[Sequence[pulumi.Input['CodeToolsSettingEnabledToolArgs']]]] = None,
                 labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 location: Optional[pulumi.Input[builtins.str]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 project: Optional[pulumi.Input[builtins.str]] = None,
                 pulumi_labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 update_time: Optional[pulumi.Input[builtins.str]] = None):
        """
        Input properties used for looking up and filtering CodeToolsSetting resources.
        :param pulumi.Input[builtins.str] code_tools_setting_id: Id of the Code Tools Setting.
        :param pulumi.Input[builtins.str] create_time: Create time stamp.
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] effective_labels: All of labels (key/value pairs) present on the resource in GCP, including the labels configured through Pulumi, other clients and services.
        :param pulumi.Input[Sequence[pulumi.Input['CodeToolsSettingEnabledToolArgs']]] enabled_tools: Represents the full set of enabled tools.
               Structure is documented below.
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] labels: Labels as key value pairs. **Note**: This field is non-authoritative, and will only manage the labels present in your
               configuration. Please refer to the field 'effective_labels' for all of the labels present on the resource.
        :param pulumi.Input[builtins.str] location: Resource ID segment making up resource 'name'. It identifies the resource within its parent collection as described in
               https://google.aip.dev/122.
        :param pulumi.Input[builtins.str] name: Identifier. Name of the resource.
               Format:projects/{project}/locations/{location}/codeToolsSettings/{codeToolsSetting}
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] pulumi_labels: The combination of labels configured directly on the resource
               and default labels configured on the provider.
        :param pulumi.Input[builtins.str] update_time: Update time stamp.
        """
        if code_tools_setting_id is not None:
            pulumi.set(__self__, "code_tools_setting_id", code_tools_setting_id)
        if create_time is not None:
            pulumi.set(__self__, "create_time", create_time)
        if effective_labels is not None:
            pulumi.set(__self__, "effective_labels", effective_labels)
        if enabled_tools is not None:
            pulumi.set(__self__, "enabled_tools", enabled_tools)
        if labels is not None:
            pulumi.set(__self__, "labels", labels)
        if location is not None:
            pulumi.set(__self__, "location", location)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if project is not None:
            pulumi.set(__self__, "project", project)
        if pulumi_labels is not None:
            pulumi.set(__self__, "pulumi_labels", pulumi_labels)
        if update_time is not None:
            pulumi.set(__self__, "update_time", update_time)

    @property
    @pulumi.getter(name="codeToolsSettingId")
    def code_tools_setting_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Id of the Code Tools Setting.
        """
        return pulumi.get(self, "code_tools_setting_id")

    @code_tools_setting_id.setter
    def code_tools_setting_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "code_tools_setting_id", value)

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Create time stamp.
        """
        return pulumi.get(self, "create_time")

    @create_time.setter
    def create_time(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "create_time", value)

    @property
    @pulumi.getter(name="effectiveLabels")
    def effective_labels(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]:
        """
        All of labels (key/value pairs) present on the resource in GCP, including the labels configured through Pulumi, other clients and services.
        """
        return pulumi.get(self, "effective_labels")

    @effective_labels.setter
    def effective_labels(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "effective_labels", value)

    @property
    @pulumi.getter(name="enabledTools")
    def enabled_tools(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['CodeToolsSettingEnabledToolArgs']]]]:
        """
        Represents the full set of enabled tools.
        Structure is documented below.
        """
        return pulumi.get(self, "enabled_tools")

    @enabled_tools.setter
    def enabled_tools(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['CodeToolsSettingEnabledToolArgs']]]]):
        pulumi.set(self, "enabled_tools", value)

    @property
    @pulumi.getter
    def labels(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]:
        """
        Labels as key value pairs. **Note**: This field is non-authoritative, and will only manage the labels present in your
        configuration. Please refer to the field 'effective_labels' for all of the labels present on the resource.
        """
        return pulumi.get(self, "labels")

    @labels.setter
    def labels(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "labels", value)

    @property
    @pulumi.getter
    def location(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Resource ID segment making up resource 'name'. It identifies the resource within its parent collection as described in
        https://google.aip.dev/122.
        """
        return pulumi.get(self, "location")

    @location.setter
    def location(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "location", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Identifier. Name of the resource.
        Format:projects/{project}/locations/{location}/codeToolsSettings/{codeToolsSetting}
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def project(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "project")

    @project.setter
    def project(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "project", value)

    @property
    @pulumi.getter(name="pulumiLabels")
    def pulumi_labels(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]:
        """
        The combination of labels configured directly on the resource
        and default labels configured on the provider.
        """
        return pulumi.get(self, "pulumi_labels")

    @pulumi_labels.setter
    def pulumi_labels(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "pulumi_labels", value)

    @property
    @pulumi.getter(name="updateTime")
    def update_time(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Update time stamp.
        """
        return pulumi.get(self, "update_time")

    @update_time.setter
    def update_time(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "update_time", value)


@pulumi.type_token("gcp:gemini/codeToolsSetting:CodeToolsSetting")
class CodeToolsSetting(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 code_tools_setting_id: Optional[pulumi.Input[builtins.str]] = None,
                 enabled_tools: Optional[pulumi.Input[Sequence[pulumi.Input[Union['CodeToolsSettingEnabledToolArgs', 'CodeToolsSettingEnabledToolArgsDict']]]]] = None,
                 labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 location: Optional[pulumi.Input[builtins.str]] = None,
                 project: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        """
        The resource for managing CodeTools settings for Admin Control.

        ## Example Usage

        ### Gemini Code Tools Setting Basic

        ```python
        import pulumi
        import pulumi_gcp as gcp

        example = gcp.gemini.CodeToolsSetting("example",
            code_tools_setting_id="ls1-tf",
            location="global",
            labels={
                "my_key": "my_value",
            },
            enabled_tools=[{
                "handle": "my_handle",
                "tool": "my_tool",
                "account_connector": "my_con",
                "configs": [{
                    "key": "my_key",
                    "value": "my_value",
                }],
                "uri_override": "my_uri_override",
            }])
        ```

        ## Import

        CodeToolsSetting can be imported using any of these accepted formats:

        * `projects/{{project}}/locations/{{location}}/codeToolsSettings/{{code_tools_setting_id}}`

        * `{{project}}/{{location}}/{{code_tools_setting_id}}`

        * `{{location}}/{{code_tools_setting_id}}`

        When using the `pulumi import` command, CodeToolsSetting can be imported using one of the formats above. For example:

        ```sh
        $ pulumi import gcp:gemini/codeToolsSetting:CodeToolsSetting default projects/{{project}}/locations/{{location}}/codeToolsSettings/{{code_tools_setting_id}}
        ```

        ```sh
        $ pulumi import gcp:gemini/codeToolsSetting:CodeToolsSetting default {{project}}/{{location}}/{{code_tools_setting_id}}
        ```

        ```sh
        $ pulumi import gcp:gemini/codeToolsSetting:CodeToolsSetting default {{location}}/{{code_tools_setting_id}}
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] code_tools_setting_id: Id of the Code Tools Setting.
        :param pulumi.Input[Sequence[pulumi.Input[Union['CodeToolsSettingEnabledToolArgs', 'CodeToolsSettingEnabledToolArgsDict']]]] enabled_tools: Represents the full set of enabled tools.
               Structure is documented below.
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] labels: Labels as key value pairs. **Note**: This field is non-authoritative, and will only manage the labels present in your
               configuration. Please refer to the field 'effective_labels' for all of the labels present on the resource.
        :param pulumi.Input[builtins.str] location: Resource ID segment making up resource 'name'. It identifies the resource within its parent collection as described in
               https://google.aip.dev/122.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: CodeToolsSettingArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        The resource for managing CodeTools settings for Admin Control.

        ## Example Usage

        ### Gemini Code Tools Setting Basic

        ```python
        import pulumi
        import pulumi_gcp as gcp

        example = gcp.gemini.CodeToolsSetting("example",
            code_tools_setting_id="ls1-tf",
            location="global",
            labels={
                "my_key": "my_value",
            },
            enabled_tools=[{
                "handle": "my_handle",
                "tool": "my_tool",
                "account_connector": "my_con",
                "configs": [{
                    "key": "my_key",
                    "value": "my_value",
                }],
                "uri_override": "my_uri_override",
            }])
        ```

        ## Import

        CodeToolsSetting can be imported using any of these accepted formats:

        * `projects/{{project}}/locations/{{location}}/codeToolsSettings/{{code_tools_setting_id}}`

        * `{{project}}/{{location}}/{{code_tools_setting_id}}`

        * `{{location}}/{{code_tools_setting_id}}`

        When using the `pulumi import` command, CodeToolsSetting can be imported using one of the formats above. For example:

        ```sh
        $ pulumi import gcp:gemini/codeToolsSetting:CodeToolsSetting default projects/{{project}}/locations/{{location}}/codeToolsSettings/{{code_tools_setting_id}}
        ```

        ```sh
        $ pulumi import gcp:gemini/codeToolsSetting:CodeToolsSetting default {{project}}/{{location}}/{{code_tools_setting_id}}
        ```

        ```sh
        $ pulumi import gcp:gemini/codeToolsSetting:CodeToolsSetting default {{location}}/{{code_tools_setting_id}}
        ```

        :param str resource_name: The name of the resource.
        :param CodeToolsSettingArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(CodeToolsSettingArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 code_tools_setting_id: Optional[pulumi.Input[builtins.str]] = None,
                 enabled_tools: Optional[pulumi.Input[Sequence[pulumi.Input[Union['CodeToolsSettingEnabledToolArgs', 'CodeToolsSettingEnabledToolArgsDict']]]]] = None,
                 labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 location: Optional[pulumi.Input[builtins.str]] = None,
                 project: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = CodeToolsSettingArgs.__new__(CodeToolsSettingArgs)

            if code_tools_setting_id is None and not opts.urn:
                raise TypeError("Missing required property 'code_tools_setting_id'")
            __props__.__dict__["code_tools_setting_id"] = code_tools_setting_id
            if enabled_tools is None and not opts.urn:
                raise TypeError("Missing required property 'enabled_tools'")
            __props__.__dict__["enabled_tools"] = enabled_tools
            __props__.__dict__["labels"] = labels
            __props__.__dict__["location"] = location
            __props__.__dict__["project"] = project
            __props__.__dict__["create_time"] = None
            __props__.__dict__["effective_labels"] = None
            __props__.__dict__["name"] = None
            __props__.__dict__["pulumi_labels"] = None
            __props__.__dict__["update_time"] = None
        secret_opts = pulumi.ResourceOptions(additional_secret_outputs=["effectiveLabels", "pulumiLabels"])
        opts = pulumi.ResourceOptions.merge(opts, secret_opts)
        super(CodeToolsSetting, __self__).__init__(
            'gcp:gemini/codeToolsSetting:CodeToolsSetting',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            code_tools_setting_id: Optional[pulumi.Input[builtins.str]] = None,
            create_time: Optional[pulumi.Input[builtins.str]] = None,
            effective_labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
            enabled_tools: Optional[pulumi.Input[Sequence[pulumi.Input[Union['CodeToolsSettingEnabledToolArgs', 'CodeToolsSettingEnabledToolArgsDict']]]]] = None,
            labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
            location: Optional[pulumi.Input[builtins.str]] = None,
            name: Optional[pulumi.Input[builtins.str]] = None,
            project: Optional[pulumi.Input[builtins.str]] = None,
            pulumi_labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
            update_time: Optional[pulumi.Input[builtins.str]] = None) -> 'CodeToolsSetting':
        """
        Get an existing CodeToolsSetting resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] code_tools_setting_id: Id of the Code Tools Setting.
        :param pulumi.Input[builtins.str] create_time: Create time stamp.
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] effective_labels: All of labels (key/value pairs) present on the resource in GCP, including the labels configured through Pulumi, other clients and services.
        :param pulumi.Input[Sequence[pulumi.Input[Union['CodeToolsSettingEnabledToolArgs', 'CodeToolsSettingEnabledToolArgsDict']]]] enabled_tools: Represents the full set of enabled tools.
               Structure is documented below.
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] labels: Labels as key value pairs. **Note**: This field is non-authoritative, and will only manage the labels present in your
               configuration. Please refer to the field 'effective_labels' for all of the labels present on the resource.
        :param pulumi.Input[builtins.str] location: Resource ID segment making up resource 'name'. It identifies the resource within its parent collection as described in
               https://google.aip.dev/122.
        :param pulumi.Input[builtins.str] name: Identifier. Name of the resource.
               Format:projects/{project}/locations/{location}/codeToolsSettings/{codeToolsSetting}
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] pulumi_labels: The combination of labels configured directly on the resource
               and default labels configured on the provider.
        :param pulumi.Input[builtins.str] update_time: Update time stamp.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _CodeToolsSettingState.__new__(_CodeToolsSettingState)

        __props__.__dict__["code_tools_setting_id"] = code_tools_setting_id
        __props__.__dict__["create_time"] = create_time
        __props__.__dict__["effective_labels"] = effective_labels
        __props__.__dict__["enabled_tools"] = enabled_tools
        __props__.__dict__["labels"] = labels
        __props__.__dict__["location"] = location
        __props__.__dict__["name"] = name
        __props__.__dict__["project"] = project
        __props__.__dict__["pulumi_labels"] = pulumi_labels
        __props__.__dict__["update_time"] = update_time
        return CodeToolsSetting(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="codeToolsSettingId")
    def code_tools_setting_id(self) -> pulumi.Output[builtins.str]:
        """
        Id of the Code Tools Setting.
        """
        return pulumi.get(self, "code_tools_setting_id")

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> pulumi.Output[builtins.str]:
        """
        Create time stamp.
        """
        return pulumi.get(self, "create_time")

    @property
    @pulumi.getter(name="effectiveLabels")
    def effective_labels(self) -> pulumi.Output[Mapping[str, builtins.str]]:
        """
        All of labels (key/value pairs) present on the resource in GCP, including the labels configured through Pulumi, other clients and services.
        """
        return pulumi.get(self, "effective_labels")

    @property
    @pulumi.getter(name="enabledTools")
    def enabled_tools(self) -> pulumi.Output[Sequence['outputs.CodeToolsSettingEnabledTool']]:
        """
        Represents the full set of enabled tools.
        Structure is documented below.
        """
        return pulumi.get(self, "enabled_tools")

    @property
    @pulumi.getter
    def labels(self) -> pulumi.Output[Optional[Mapping[str, builtins.str]]]:
        """
        Labels as key value pairs. **Note**: This field is non-authoritative, and will only manage the labels present in your
        configuration. Please refer to the field 'effective_labels' for all of the labels present on the resource.
        """
        return pulumi.get(self, "labels")

    @property
    @pulumi.getter
    def location(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        Resource ID segment making up resource 'name'. It identifies the resource within its parent collection as described in
        https://google.aip.dev/122.
        """
        return pulumi.get(self, "location")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[builtins.str]:
        """
        Identifier. Name of the resource.
        Format:projects/{project}/locations/{location}/codeToolsSettings/{codeToolsSetting}
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def project(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "project")

    @property
    @pulumi.getter(name="pulumiLabels")
    def pulumi_labels(self) -> pulumi.Output[Mapping[str, builtins.str]]:
        """
        The combination of labels configured directly on the resource
        and default labels configured on the provider.
        """
        return pulumi.get(self, "pulumi_labels")

    @property
    @pulumi.getter(name="updateTime")
    def update_time(self) -> pulumi.Output[builtins.str]:
        """
        Update time stamp.
        """
        return pulumi.get(self, "update_time")

