# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'ParameterPolicyMemberArgs',
    'ParameterPolicyMemberArgsDict',
    'RegionalParameterPolicyMemberArgs',
    'RegionalParameterPolicyMemberArgsDict',
]

MYPY = False

if not MYPY:
    class ParameterPolicyMemberArgsDict(TypedDict):
        iam_policy_name_principal: NotRequired[pulumi.Input[builtins.str]]
        """
        (Output)
        IAM policy binding member referring to a Google Cloud resource by user-assigned name. If a
        resource is deleted and recreated with the same name, the binding will be applicable to the
        new resource. Format:
        `principal://parametermanager.googleapis.com/projects/{{project}}/name/locations/global/parameters/{{parameter_id}}`
        """
        iam_policy_uid_principal: NotRequired[pulumi.Input[builtins.str]]
        """
        (Output)
        IAM policy binding member referring to a Google Cloud resource by system-assigned unique identifier.
        If a resource is deleted and recreated with the same name, the binding will not be applicable to the
        new resource. Format:
        `principal://parametermanager.googleapis.com/projects/{{project}}/uid/locations/global/parameters/{{uid}}`
        """
elif False:
    ParameterPolicyMemberArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class ParameterPolicyMemberArgs:
    def __init__(__self__, *,
                 iam_policy_name_principal: Optional[pulumi.Input[builtins.str]] = None,
                 iam_policy_uid_principal: Optional[pulumi.Input[builtins.str]] = None):
        """
        :param pulumi.Input[builtins.str] iam_policy_name_principal: (Output)
               IAM policy binding member referring to a Google Cloud resource by user-assigned name. If a
               resource is deleted and recreated with the same name, the binding will be applicable to the
               new resource. Format:
               `principal://parametermanager.googleapis.com/projects/{{project}}/name/locations/global/parameters/{{parameter_id}}`
        :param pulumi.Input[builtins.str] iam_policy_uid_principal: (Output)
               IAM policy binding member referring to a Google Cloud resource by system-assigned unique identifier.
               If a resource is deleted and recreated with the same name, the binding will not be applicable to the
               new resource. Format:
               `principal://parametermanager.googleapis.com/projects/{{project}}/uid/locations/global/parameters/{{uid}}`
        """
        if iam_policy_name_principal is not None:
            pulumi.set(__self__, "iam_policy_name_principal", iam_policy_name_principal)
        if iam_policy_uid_principal is not None:
            pulumi.set(__self__, "iam_policy_uid_principal", iam_policy_uid_principal)

    @property
    @pulumi.getter(name="iamPolicyNamePrincipal")
    def iam_policy_name_principal(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        (Output)
        IAM policy binding member referring to a Google Cloud resource by user-assigned name. If a
        resource is deleted and recreated with the same name, the binding will be applicable to the
        new resource. Format:
        `principal://parametermanager.googleapis.com/projects/{{project}}/name/locations/global/parameters/{{parameter_id}}`
        """
        return pulumi.get(self, "iam_policy_name_principal")

    @iam_policy_name_principal.setter
    def iam_policy_name_principal(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "iam_policy_name_principal", value)

    @property
    @pulumi.getter(name="iamPolicyUidPrincipal")
    def iam_policy_uid_principal(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        (Output)
        IAM policy binding member referring to a Google Cloud resource by system-assigned unique identifier.
        If a resource is deleted and recreated with the same name, the binding will not be applicable to the
        new resource. Format:
        `principal://parametermanager.googleapis.com/projects/{{project}}/uid/locations/global/parameters/{{uid}}`
        """
        return pulumi.get(self, "iam_policy_uid_principal")

    @iam_policy_uid_principal.setter
    def iam_policy_uid_principal(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "iam_policy_uid_principal", value)


if not MYPY:
    class RegionalParameterPolicyMemberArgsDict(TypedDict):
        iam_policy_name_principal: NotRequired[pulumi.Input[builtins.str]]
        """
        (Output)
        IAM policy binding member referring to a Google Cloud resource by user-assigned name. If a resource is
        deleted and recreated with the same name, the binding will be applicable to the new resource. Format:
        `principal://parametermanager.googleapis.com/projects/{{project}}/name/locations/{{location}}/parameters/{{parameter_id}}`
        """
        iam_policy_uid_principal: NotRequired[pulumi.Input[builtins.str]]
        """
        (Output)
        IAM policy binding member referring to a Google Cloud resource by system-assigned unique identifier. If
        a resource is deleted and recreated with the same name, the binding will not be applicable to the new
        resource. Format:
        `principal://parametermanager.googleapis.com/projects/{{project}}/uid/locations/{{location}}/parameters/{{uid}}`
        """
elif False:
    RegionalParameterPolicyMemberArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class RegionalParameterPolicyMemberArgs:
    def __init__(__self__, *,
                 iam_policy_name_principal: Optional[pulumi.Input[builtins.str]] = None,
                 iam_policy_uid_principal: Optional[pulumi.Input[builtins.str]] = None):
        """
        :param pulumi.Input[builtins.str] iam_policy_name_principal: (Output)
               IAM policy binding member referring to a Google Cloud resource by user-assigned name. If a resource is
               deleted and recreated with the same name, the binding will be applicable to the new resource. Format:
               `principal://parametermanager.googleapis.com/projects/{{project}}/name/locations/{{location}}/parameters/{{parameter_id}}`
        :param pulumi.Input[builtins.str] iam_policy_uid_principal: (Output)
               IAM policy binding member referring to a Google Cloud resource by system-assigned unique identifier. If
               a resource is deleted and recreated with the same name, the binding will not be applicable to the new
               resource. Format:
               `principal://parametermanager.googleapis.com/projects/{{project}}/uid/locations/{{location}}/parameters/{{uid}}`
        """
        if iam_policy_name_principal is not None:
            pulumi.set(__self__, "iam_policy_name_principal", iam_policy_name_principal)
        if iam_policy_uid_principal is not None:
            pulumi.set(__self__, "iam_policy_uid_principal", iam_policy_uid_principal)

    @property
    @pulumi.getter(name="iamPolicyNamePrincipal")
    def iam_policy_name_principal(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        (Output)
        IAM policy binding member referring to a Google Cloud resource by user-assigned name. If a resource is
        deleted and recreated with the same name, the binding will be applicable to the new resource. Format:
        `principal://parametermanager.googleapis.com/projects/{{project}}/name/locations/{{location}}/parameters/{{parameter_id}}`
        """
        return pulumi.get(self, "iam_policy_name_principal")

    @iam_policy_name_principal.setter
    def iam_policy_name_principal(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "iam_policy_name_principal", value)

    @property
    @pulumi.getter(name="iamPolicyUidPrincipal")
    def iam_policy_uid_principal(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        (Output)
        IAM policy binding member referring to a Google Cloud resource by system-assigned unique identifier. If
        a resource is deleted and recreated with the same name, the binding will not be applicable to the new
        resource. Format:
        `principal://parametermanager.googleapis.com/projects/{{project}}/uid/locations/{{location}}/parameters/{{uid}}`
        """
        return pulumi.get(self, "iam_policy_uid_principal")

    @iam_policy_uid_principal.setter
    def iam_policy_uid_principal(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "iam_policy_uid_principal", value)


