# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetControlOrganizationIntelligenceConfigResult',
    'AwaitableGetControlOrganizationIntelligenceConfigResult',
    'get_control_organization_intelligence_config',
    'get_control_organization_intelligence_config_output',
]

@pulumi.output_type
class GetControlOrganizationIntelligenceConfigResult:
    """
    A collection of values returned by getControlOrganizationIntelligenceConfig.
    """
    def __init__(__self__, edition_config=None, effective_intelligence_configs=None, filters=None, id=None, name=None, trial_configs=None, update_time=None):
        if edition_config and not isinstance(edition_config, str):
            raise TypeError("Expected argument 'edition_config' to be a str")
        pulumi.set(__self__, "edition_config", edition_config)
        if effective_intelligence_configs and not isinstance(effective_intelligence_configs, list):
            raise TypeError("Expected argument 'effective_intelligence_configs' to be a list")
        pulumi.set(__self__, "effective_intelligence_configs", effective_intelligence_configs)
        if filters and not isinstance(filters, list):
            raise TypeError("Expected argument 'filters' to be a list")
        pulumi.set(__self__, "filters", filters)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if trial_configs and not isinstance(trial_configs, list):
            raise TypeError("Expected argument 'trial_configs' to be a list")
        pulumi.set(__self__, "trial_configs", trial_configs)
        if update_time and not isinstance(update_time, str):
            raise TypeError("Expected argument 'update_time' to be a str")
        pulumi.set(__self__, "update_time", update_time)

    @property
    @pulumi.getter(name="editionConfig")
    def edition_config(self) -> builtins.str:
        return pulumi.get(self, "edition_config")

    @property
    @pulumi.getter(name="effectiveIntelligenceConfigs")
    def effective_intelligence_configs(self) -> Sequence['outputs.GetControlOrganizationIntelligenceConfigEffectiveIntelligenceConfigResult']:
        return pulumi.get(self, "effective_intelligence_configs")

    @property
    @pulumi.getter
    def filters(self) -> Sequence['outputs.GetControlOrganizationIntelligenceConfigFilterResult']:
        return pulumi.get(self, "filters")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="trialConfigs")
    def trial_configs(self) -> Sequence['outputs.GetControlOrganizationIntelligenceConfigTrialConfigResult']:
        return pulumi.get(self, "trial_configs")

    @property
    @pulumi.getter(name="updateTime")
    def update_time(self) -> builtins.str:
        return pulumi.get(self, "update_time")


class AwaitableGetControlOrganizationIntelligenceConfigResult(GetControlOrganizationIntelligenceConfigResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetControlOrganizationIntelligenceConfigResult(
            edition_config=self.edition_config,
            effective_intelligence_configs=self.effective_intelligence_configs,
            filters=self.filters,
            id=self.id,
            name=self.name,
            trial_configs=self.trial_configs,
            update_time=self.update_time)


def get_control_organization_intelligence_config(name: Optional[builtins.str] = None,
                                                 opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetControlOrganizationIntelligenceConfigResult:
    """
    Use this data source to get information about a Organization Storage Intelligence config resource.
    See [the official documentation](https://cloud.google.com/storage/docs/storage-intelligence/overview#resource)
    and
    [API](https://cloud.google.com/storage/docs/json_api/v1/intelligenceConfig).

    ## Example Usage

    ```python
    import pulumi
    import pulumi_gcp as gcp

    sample_config = gcp.storage.get_control_organization_intelligence_config(name="123456789")
    ```


    :param builtins.str name: The id of GCP organization.
    """
    __args__ = dict()
    __args__['name'] = name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('gcp:storage/getControlOrganizationIntelligenceConfig:getControlOrganizationIntelligenceConfig', __args__, opts=opts, typ=GetControlOrganizationIntelligenceConfigResult).value

    return AwaitableGetControlOrganizationIntelligenceConfigResult(
        edition_config=pulumi.get(__ret__, 'edition_config'),
        effective_intelligence_configs=pulumi.get(__ret__, 'effective_intelligence_configs'),
        filters=pulumi.get(__ret__, 'filters'),
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        trial_configs=pulumi.get(__ret__, 'trial_configs'),
        update_time=pulumi.get(__ret__, 'update_time'))
def get_control_organization_intelligence_config_output(name: Optional[pulumi.Input[builtins.str]] = None,
                                                        opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetControlOrganizationIntelligenceConfigResult]:
    """
    Use this data source to get information about a Organization Storage Intelligence config resource.
    See [the official documentation](https://cloud.google.com/storage/docs/storage-intelligence/overview#resource)
    and
    [API](https://cloud.google.com/storage/docs/json_api/v1/intelligenceConfig).

    ## Example Usage

    ```python
    import pulumi
    import pulumi_gcp as gcp

    sample_config = gcp.storage.get_control_organization_intelligence_config(name="123456789")
    ```


    :param builtins.str name: The id of GCP organization.
    """
    __args__ = dict()
    __args__['name'] = name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('gcp:storage/getControlOrganizationIntelligenceConfig:getControlOrganizationIntelligenceConfig', __args__, opts=opts, typ=GetControlOrganizationIntelligenceConfigResult)
    return __ret__.apply(lambda __response__: GetControlOrganizationIntelligenceConfigResult(
        edition_config=pulumi.get(__response__, 'edition_config'),
        effective_intelligence_configs=pulumi.get(__response__, 'effective_intelligence_configs'),
        filters=pulumi.get(__response__, 'filters'),
        id=pulumi.get(__response__, 'id'),
        name=pulumi.get(__response__, 'name'),
        trial_configs=pulumi.get(__response__, 'trial_configs'),
        update_time=pulumi.get(__response__, 'update_time')))
